<?php
class ControllerExtensionPaymentCryptexy extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/cryptexy');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_cryptexy', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

        $data['log_filename'] = 'cryptexy.log';
        $data['log_lines']  = $this->readLastLines(DIR_LOGS . $data['log_filename'], 500);
        $data['clear_log']  = str_replace('&amp;', '&', $this->url->link('extension/payment/cryptexy/clearlog', 'user_token=' . $this->session->data['user_token'], true));

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['api_key'])) {
			$data['error_api_key'] = $this->error['api_key'];
		} else {
			$data['error_api_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/cryptexy', 'user_token=' . $this->session->data['user_token'], true)
		);



		$data['action'] = $this->url->link('extension/payment/cryptexy', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_cryptexy_api_key'])) {
			$data['payment_cryptexy_api_key'] = $this->request->post['payment_cryptexy_api_key'];
		} else {
			$data['payment_cryptexy_api_key'] = $this->config->get('payment_cryptexy_api_key');
		}

		if (isset($this->request->post['payment_cryptexy_debug'])) {
			$data['payment_cryptexy_debug'] = $this->request->post['payment_cryptexy_debug'];
		} else {
			$data['payment_cryptexy_debug'] = $this->config->get('payment_cryptexy_debug');
		}

		if (isset($this->request->post['payment_cryptexy_total'])) {
			$data['payment_cryptexy_total'] = $this->request->post['payment_cryptexy_total'];
		} else {
			$data['payment_cryptexy_total'] = $this->config->get('payment_cryptexy_total');
		}

		if (isset($this->request->post['payment_cryptexy_completed_status_id'])) {
			$data['payment_cryptexy_completed_status_id'] = $this->request->post['payment_cryptexy_completed_status_id'];
		} else {
			$data['payment_cryptexy_completed_status_id'] = $this->config->get('payment_cryptexy_completed_status_id');
		}

        if (isset($this->request->post['payment_cryptexy_less_status_id'])) {
            $data['payment_cryptexy_less_status_id'] = $this->request->post['payment_cryptexy_less_status_id'];
        } else {
            $data['payment_cryptexy_less_status_id'] = $this->config->get('payment_cryptexy_less_status_id');
        }

        if (isset($this->request->post['payment_cryptexy_more_status_id'])) {
            $data['payment_cryptexy_more_status_id'] = $this->request->post['payment_cryptexy_more_status_id'];
        } else {
            $data['payment_cryptexy_more_status_id'] = $this->config->get('payment_cryptexy_more_status_id');
        }

		if (isset($this->request->post['payment_cryptexy_failed_status_id'])) {
			$data['payment_cryptexy_failed_status_id'] = $this->request->post['payment_cryptexy_failed_status_id'];
		} else {
			$data['payment_cryptexy_failed_status_id'] = $this->config->get('payment_cryptexy_failed_status_id');
		}

		if (isset($this->request->post['payment_cryptexy_pending_status_id'])) {
			$data['payment_cryptexy_pending_status_id'] = $this->request->post['payment_cryptexy_pending_status_id'];
		} else {
			$data['payment_cryptexy_pending_status_id'] = $this->config->get('payment_cryptexy_pending_status_id');
		}


		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_cryptexy_geo_zone_id'])) {
			$data['payment_cryptexy_geo_zone_id'] = $this->request->post['payment_cryptexy_geo_zone_id'];
		} else {
			$data['payment_cryptexy_geo_zone_id'] = $this->config->get('payment_cryptexy_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_cryptexy_status'])) {
			$data['payment_cryptexy_status'] = $this->request->post['payment_cryptexy_status'];
		} else {
			$data['payment_cryptexy_status'] = $this->config->get('payment_cryptexy_status');
		}

		if (isset($this->request->post['payment_cryptexy_sort_order'])) {
			$data['payment_cryptexy_sort_order'] = $this->request->post['payment_cryptexy_sort_order'];
		} else {
			$data['payment_cryptexy_sort_order'] = $this->config->get('payment_cryptexy_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/cryptexy', $data));
	}
    public function install() {
        $this->load->model('localisation/order_status');
        $this->load->model('localisation/language');


        $langs = $this->model_localisation_language->getLanguages();

        $default_params = array();

        $i = 0;

        foreach ($langs as $lang) {

            $this->model_localisation_order_status->addOrderStatus(array(
                'order_status' => array(
                    $lang['language_id'] => array('name' => 'Cryptexy: Полная оплата')
                )
            ));

            if ($i == 0) $default_params['payment_cryptexy_completed_status_id'] = $this->db->getLastId();

            $this->model_localisation_order_status->addOrderStatus(array(
                'order_status' => array(
                    $lang['language_id'] => array('name' => 'Cryptexy: Неполная оплата')
                )
            ));

            if ($i == 0) $default_params['payment_cryptexy_less_status_id'] = $this->db->getLastId();

            $this->model_localisation_order_status->addOrderStatus(array(
                'order_status' => array(
                    $lang['language_id'] => array('name' => 'Cryptexy: Переплата')
                )
            ));

            if ($i == 0) $default_params['payment_cryptexy_more_status_id'] = $this->db->getLastId();

            $i++;
        }

        $this->load->model('setting/setting');

        $this->model_setting_setting->editSetting('payment_cryptexy', $default_params);
    }

    public function uninstall() {
        $this->load->model('localisation/order_status');

        $this->load->model('localisation/language');

        $this->load->model('setting/setting');

        $this->model_setting_setting->deleteSetting('payment_cryptexy');

        $this->db->query("DELETE FROM " . DB_PREFIX . "order_status WHERE name = 'Cryptexy: Полная оплата' ");

        $this->db->query("DELETE FROM " . DB_PREFIX . "order_status WHERE name = 'Cryptexy: Неполная оплата' ");

        $this->db->query("DELETE FROM " . DB_PREFIX . "order_status WHERE name = 'Cryptexy: Переплата' ");

    }
	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/cryptexy')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['payment_cryptexy_api_key']) {
			$this->error['api_key'] = $this->language->get('error_api_key');
		}

		return !$this->error;
	}
    public function clearLog() {
        $json = array();
        $this->load->language('extension/payment/cryptexy');
        if ($this->validatePermission()) {
            if (is_file(DIR_LOGS . 'cryptexy.log')) {
                @unlink(DIR_LOGS . 'cryptexy.log');
            }
            $json['success'] = $this->language->get('text_clear_log_success');
        } else {
            $json['error'] = $this->language->get('error_permission');
        }

        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));
    }

    protected function validatePermission() {
        return $this->user->hasPermission('modify', 'extension/payment/cryptexy');
    }

    protected function readLastLines($filename, $lines) {
        if (!is_file($filename)) {
            return array();
        }
        $handle = @fopen($filename, "r");
        if (!$handle) {
            return array();
        }
        $linecounter = $lines;
        $pos = -1;
        $beginning = false;
        $text = array();

        while ($linecounter > 0) {
            $t = " ";

            while ($t != "\n") {
                /* if fseek() returns -1 we need to break the cycle*/
                if (fseek($handle, $pos, SEEK_END) == -1) {
                    $beginning = true;
                    break;
                }
                $t = fgetc($handle);
                $pos--;
            }

            $linecounter--;

            if ($beginning) {
                rewind($handle);
            }

            $text[$lines - $linecounter - 1] = fgets($handle);

            if ($beginning) {
                break;
            }
        }
        fclose($handle);

        return array_reverse($text);
    }
}