<?php
class ModelExtensionPaymentCryptexy extends Model {
	public function getMethod($address, $total) {
		$this->load->language('extension/payment/cryptexy');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('payment_cryptexy_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		if ($this->config->get('payment_cryptexy_total') > $total) {
			$status = false;
		} elseif (!$this->config->get('payment_cryptexy_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

        /*$currencies = array(

            'RUR',
            'RUB'
        );

        if (!in_array(strtoupper($this->session->data['currency']), $currencies)) {
            $status = false;
        }*/

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'cryptexy',
				'title'      => $this->language->get('text_title'),
				'terms'      => '',
				'sort_order' => $this->config->get('payment_cryptexy_sort_order')
			);
		}

		return $method_data;
	}

    public function sendCurl($url, $fields) {
        $curl = curl_init($url);

        curl_setopt($curl, CURLOPT_HTTPHEADER, ['Content-type: application/json']); // Requesting JSON.
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); // Return into variable without sending to client.

        // Send POST request.
        curl_setopt($curl, CURLOPT_POST, 1);
        // Send as a form.
        curl_setopt($curl, CURLOPT_HTTPHEADER, ['Content-Type: application/x-www-form-urlencoded']);

        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($fields));
        $response = curl_exec($curl);

        curl_close($curl);
        if (!$response) {
            $this->logger('Curl failed: ' . curl_error($curl) . '(' . curl_errno($curl) . ')');
        }
        return json_decode($response);
    }

    public function updateOrderInfo($order_id, $code) {
        $this->db->query("UPDATE `" . DB_PREFIX . "order` SET  payment_custom_field = '" . $this->db->escape($code ). "' WHERE order_id = '" . (int)$order_id . "'");

    }

    public function getOrderByCode($code) {
        $qry = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order` WHERE payment_custom_field = '" . $this->db->escape($code). "' LIMIT 1");
        if ($qry->num_rows) {
            return $qry->row;
        } else {
            return false;
        }
    }

    public function logger($message) {
        if ($this->config->get('payment_cryptexy_debug') == 1) {
            $log = new Log('cryptexy.log');
            $backtrace = debug_backtrace();
            $log->write('Origin: ' . $backtrace[6]['class'] . '::' . $backtrace[6]['function']);
            $log->write(print_r($message, 1));
        }
    }
}
